/** 
 *  Sample program for Hyper Operating System V4 Advance
 *
 * @file  sample.c
 * @brief ץץ
 *
 * @version $Id: sample.c,v 1.1.1.1 2006/08/16 16:27:04 ryuz Exp $
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "kernel.h"
#include "kernel_id.h"
#include "sample.h"
#include "sci1.h"
#include "regs_sh7144.h"

/* ϥɥ */
void Sample_Initialize(VP_INT exinf)
{
	/* ư */
	act_tsk(TSKID_PRINT);
	act_tsk(TSKID_SAMPLE1);
}

/* 100msԤ */
void t_wait(void)
{
	dly_tsk(100);	
}

/* ɽ */
void print(char *text)
{
	T_PRINT_MSG *msg;
	VP  mem;
	
	/*  */
	get_mpf(MPFID, &mem);
	msg = (T_PRINT_MSG *)mem;

	/* ʸ */
	strcpy(&msg->text[0], text);
	strcat(msg->text, "\n");
	
	/* ɽ */
	snd_mbx(MBXID, (T_MSG *)msg);
}

/* ץ륿 */
void Sample_Task(VP_INT exinf)
{
	char buf[16];
	unsigned int wc,wd;
	unsigned int wb;
	unsigned int we = 0x0000;
	print("Start\r");

	for ( ; ; )
	{
		wc = *REG_PC_DR; /* ݡC  */
		wc &= 0x0400;
		wd = *REG_PD_DR; /* ݡD  */
		wd &= 0x0400;
		buf[0] = 0;
		wb = 0;
		if (wc) {
		  strcat(buf, "SW1:ON ");
		  wb |= 0x0080; /* LED1 ON */
		} else {
		  strcat(buf, "SW1:OFF ");
		}
		if(wd) {
		  wb |= 0x0040; /* LED2 ON */
		  strcat(buf, "SW2:ON\r");
		} else {
		  strcat(buf, "SW2:OFF\r");
		}
		*REG_PB_DR = wb; /* ݡB  */
		print(buf);
		we = ~we;
		*REG_PE_DRL = we; /* ľLED */
		t_wait();
	}
}

/* ɽ */
void Sample_Print(VP_INT exinf)
{
	T_PRINT_MSG *msg;
	
	Sci1_Initialize();
	
	for ( ; ; )
	{
		rcv_mbx(MBXID, (T_MSG **)&msg);
/*		sim_puts(msg->text);	*/
		Sci1_PutString(msg->text);
		rel_mpf(MPFID, msg);
	}
}






/* end of file */
