/** 
 *  Sample program for Hyper Operating System V4 Advance
 *
 * @file  sci1.c
 * @brief SCI1ؤν
 *
 * @version $Id: sci1.c,v 1.1.1.1 2006/08/16 16:27:04 ryuz Exp $
 *
 * Copyright (C) 1998-2006 by Project HOS
 * http://sourceforge.jp/projects/hos/
 */


#include "kernel.h"
#include "regs_sh7144.h"


/* SCI1 ν */
void Sci1_Initialize(void)
{
	*REG_STANDBY_MSTCR1 &= ~0x0002;	/* SCI1ΥХ⡼ɤ */
	*REG_SCI1_SCR    = 0;
	*REG_SCI1_SMR    = 0;
	*REG_SCI1_BRR    = 19;			/* ܡ졼(38400bps) */
	*REG_PFC_PACRL2 |= 0x0100;		/* ü */
	*REG_SCI1_SCR   |= 0x20;		/*  */
}

/* 1ʸ */
void Sci1_PutChar(int c)
{
	while ( ((*REG_SCI1_SSR) & 0x80) != 0x80 )
		;
	
	*REG_SCI1_TDR = (UB)c;
	
	*REG_SCI1_SSR &= 0x7f;
}

/* ʸ */
void Sci1_PutString(const char *text)
{
	while ( *text != '\0' )
	{
		if ( *text == '\n' )
		{
			Sci1_PutChar('\r');
			Sci1_PutChar('\n');
		}
		else
		{
			Sci1_PutChar(*text);
		}
		
		text++;
	}
}


/* end of file */
